#! /usr/bin/env python
# -*- coding: utf-8 -*-
#作者：研发部-温赫男
#创建时间：2017年5月16日上午9:35:36
#文档位置：

'''通用函数存放位置
'''
import logging
import sys
import os
logger = logging.getLogger(__name__)
def GetDbTime(dct,idx,default = None):
    from starpro.utils import json_encode
    '''
    从字典或列表中取日期
    :param dct: 
    :param idx: 
    :param default: 
    :return: 
    '''
    try:
        datastr = dct[idx]
    except:
        datastr = None

    if datastr not in (None,""):
        try:
            return eval(json_encode(datastr))
        except:
            pass
    return default


def GetInt(dct,idx,default = 0):
    '''
    从字典或列表中取整数
    :param dct: 
    :param idx: 
    :param default: 
    :return: 
    '''

    try:
        return int(dct[idx])
    except:
        return default

def GetFloat(dct,idx,default = 0.0):
    '''
    从字典或列表中取整数
    :param dct: 
    :param idx: 
    :param default: 
    :return: 
    '''

    try:
        return float(dct[idx])
    except:
        return default


def GetStr(dct,idx,default = ""):
    '''
    从字典或列表中取整数
    :param dct: 
    :param idx: 
    :param default: 
    :return: 
    '''

    try:
        return dct[idx]
    except:
        return default

if __file__[-4:].lower() in ['.pyc', '.pyo']:
    _srcfile = __file__[:-4] + '.py'
else:
    _srcfile = __file__
_srcfile = os.path.normcase(_srcfile)

def _currentframe():
    """Return the frame object for the caller's stack frame."""
    try:
        raise Exception
    except:
        return sys.exc_info()[2].tb_frame.f_back

def _findCaller():
    f = _currentframe()
    if f is not None:
        f = f.f_back
    runfilename = "(unknown file)"
    while hasattr(f, "f_code"):
        co = f.f_code
        filename = os.path.normcase(co.co_filename)
        if filename == _srcfile:
            f = f.f_back
            continue
        runfilename = co.co_filename
        break
    return runfilename

g_Loggers = {}
def MakeLogger():
    global g_Loggers
    filename = _findCaller()
    if filename in g_Loggers:
        return g_Loggers[filename]
    g_Loggers[filename] = logger = logging.getLogger(__name__)
    logger.setLevel(logging.DEBUG)
    handle = logging.FileHandler("../logs/%s.log" % __name__)
    handle.setLevel(logging.INFO)

    formatter = logging.Formatter(
        '%(asctime)s - %(funcName)s - %(lineno)d- %(message)s')
    handle.setFormatter(formatter)

    logger.addHandler(handle)
    return logger

def SaveRequest(request):
    import starpro.logging_settings, random,datetime,json

    if  sys.argv[1] != "shell":
        logpath = starpro.logging_settings.LOG_PATH

        if request.method == "POST":
            params = request.POST
        else:
            params = request.GET

        with open("%s/params/%s_%s.json" % (logpath, __name__, datetime.datetime.now()), "w") as logfile:
            logfile.write(json.dumps([request.path, request.method, params], indent=4))



def ColorPrint(*args):
    print '\033[1;31;40m'
    print ",".join([str(i) for i in args])
    print '\033[0m'


def EN2JP(texts):
    import requests,json
    url = 'http://139.196.40.120:8008/api/translate/'
    headers = {'Authorization':'Token 5690180f352352dcb25e11a5399d54ac48d00e95'}
    params = {'text':str(texts),"source":"en","target":"ja"}
    #texts = ['库子', '衣服', '手套']

    ret = requests.get(url,params=params,headers=headers)

    dct = {}
    try:
        returndata = json.loads(ret.content)
        if returndata["ret"]:
            ct = 0
            for txt in texts:
                newtxt = returndata["data"][0]["translatedText"]
                dct[txt] = newtxt
                ct +=1
    except:
        pass
    return dct

def EN2CN(texts):
    import requests,json
    url = 'http://139.196.40.120:8008/api/translate/'
    headers = {'Authorization':'Token 5690180f352352dcb25e11a5399d54ac48d00e95'}
    params = {'text':str(texts),"source":"en","target":"zh-CN"}
    #texts = ['库子', '衣服', '手套']
    ret = requests.get(url,params=params,headers=headers)
    dct = {}
    try:
        returndata = json.loads(ret.content)
        if returndata["ret"]:
            ct = 0
            for txt in texts:
                newtxt = returndata["data"][0]["translatedText"]
                dct[txt] = newtxt
                ct +=1
    except:
        pass
    return dct
        #return dict(zip(texts,ret["data"].values()))
    # {u'data': [{u'translatedText': u'Mobile phone'}, {u'translatedText': u'Fans'}, {u'translatedText': u'pants'}],
    #  u'ret': True}
def CN2EN(texts):
    import requests,json
    url = 'http://139.196.40.120:8008/api/translate/'
    headers = {'Authorization':'Token 5690180f352352dcb25e11a5399d54ac48d00e95'}
    params = {'text':str(texts)}
    #texts = ['库子', '衣服', '手套']
    ret = requests.get(url,params=params,headers=headers)

    # source ，源文本语言，默认为zh - CN
    # target, 目标语言，默认为en

    dct = {}
    try:
        returndata = json.loads(ret.content)
        if returndata["ret"]:
           for txt in texts:
               ct = 0
               for txt in texts:
                   newtxt = returndata["data"][0]["translatedText"]
                   dct[txt] = newtxt
                   ct += 1
    except:
        pass
    return dct



def get_data_xls(filename,sheetname = "Sheet1"):
    import xlrd
    bk = xlrd.open_workbook(filename)
    try:
        sh = bk.sheet_by_name(sheetname)
    except:
        return [],"文件找不到<%s>分页"%sheetname
    # 获取行数
    nrows = sh.nrows
    # 获取列数
    ncols = sh.ncols
    print "分析<%s>,读如nrows %d, ncols %d" % (filename,nrows, ncols)

    row_list = []
    # 获取各行数据
    for i in range(1, nrows):
        row_data = sh.row_values(i)
        row_list.append(row_data)
    return row_list,""


def save_data_xls(alldata, filename,sheetname = "Sheet1"):
    import xlwt

    # 新建一个excel文件
    file = xlwt.Workbook(encoding='utf-8')

    # 新建一个sheet
    table = file.add_sheet(sheetname)

    row = 0
    for charger in alldata:
        col = 0
        for data in charger:
            table.write(row, col, data)
            col += 1
        row += 1

    file.save(filename)

def save_data_csv(alldata, filename,splicchar = ","):
    with open(filename, "w") as f:
        for data in alldata:
            data = [str(i) for i in data]
            f.write(splicchar.join(data)+"\n")



class CLog(object):
    c_LastTime = 0
    @classmethod
    def Clear(cls):
        import time
        cls.c_LastTime = time.time()

    c_Ct = 0
    c_Space = 1000
    c_MaxCt = 0
    @classmethod
    def SetSpace(cls,space,maxct):
        cls.c_Space = max(space,1)
        cls.c_MaxCt = max(maxct,1)
        cls.c_Ct = 0

    @classmethod
    def PrintSpace(cls,msg):
        cls.c_Ct+=1
        if cls.c_Ct %cls.c_Space==1:
            import time
            now = time.time()
            print msg,"%s/%s"%(cls.c_Ct,cls.c_MaxCt),"---",now-cls.c_LastTime
            #logger.info()
            #cls.c_LastTime = time.time()